import fetch from 'node-fetch';

(function(){ if(typeof document !== 'undefined'){ var head=document.head||document.getElementsByTagName('head')[0], style=document.createElement('style'), css=""; style.type='text/css'; if (style.styleSheet){ style.styleSheet.cssText = css; } else { style.appendChild(document.createTextNode(css)); } head.appendChild(style); } })();

var component = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c(_vm.tag,{tag:"component",on:{"click":function () { return _vm.disabled || _vm.openFile(); }}},[_c('input',{ref:"image",staticStyle:{"display":"none"},attrs:{"type":"file","accept":_vm.accept,"capture":_vm.capture,"disabled":_vm.disabled},on:{"change":_vm.onFilePicked}}),_vm._t("default",null,null,_vm.$data)],2)},staticRenderFns: [],
  name: 'VCloudinaryUpload',
  props: {
    accountName: { type: String, default: '' },
    autoUpload: { type: Boolean, default: false },
    capture: { type: [Boolean, String] },
    disabled: { type: Boolean, default: false },
    fileTypes: { type: [String, Array], default: '*' },
    preset: { type: String, default: '' },
    tag: { type: String, default: 'div' },
    uploadParams: { type: Object, default: function () { return ({}); } },
  },
  data: function () { return ({
    file: '',
    loading: false,
    name: '',
    url: '',
    fileReader: null,
    uploaded: null,
  }); },
  computed: {
    accept: function accept() {
      var ref = this;
      var fileTypes = ref.fileTypes;
      var accept =
        typeof fileTypes === 'string' ? fileTypes.split(',') : fileTypes;
      return accept.map(function (mime) { return ("image/" + mime); }).join(', ')
    },
  },
  methods: {
    openFile: function openFile() {
      this.$refs.image.click();
    },
    onFilePicked: function onFilePicked(e) {
      var this$1 = this;

      var files = e.target.files;
      if (files[0] !== undefined) {
        this.name = files[0].name;
        if (this.name.lastIndexOf('.') <= 0) {
          return
        }
        var fr = new FileReader();
        fr.readAsDataURL(files[0]);
        fr.addEventListener('load', function () {
          this$1.url = fr.result;
          this$1.file = files[0];
          this$1.fileReader = fr;
          this$1.$emit('picked', {
            file: this$1.file,
            name: this$1.name,
            url: this$1.url,
            fileReader: fr,
          });
          if (this$1.autoUpload) { this$1.$nextTick(function () { return this$1.upload(); }); }
        });
        return
      }
      this.name = '';
      this.file = '';
      this.url = '';
      this.fileReader = null;
      this.uploaded = null;
      this.$emit('picked', {
        file: this.file,
        name: this.name,
        url: this.url,
      });
    },
    upload: function upload(params) {
      var this$1 = this;
      if ( params === void 0 ) params = {};

      var ref = this;
      var file = ref.file;
      var upload_preset = ref.preset;
      var payload = Object.assign({}, { file: file }, params, this.params, {
        upload_preset: upload_preset,
      });
      var formData = new FormData();
      this.loading = true;
      Object.entries(payload).forEach(function (ref) {
          var key = ref[0];
          var value = ref[1];

          return formData.append(key, value);
      }
      );
      return fetch(
        ("https://api.cloudinary.com/v1_1/" + (this.accountName) + "/image/upload"),
        {
          method: 'POST',
          body: formData,
        }
      )
        .then(function (res) { return res.json(); })
        .then(function (body) {
          this$1.uploaded = body;
          this$1.$emit('uploaded', body);
          this$1.loading = false;
          return body
        })
    },
  },
}

function install(Vue) {
  if (install.installed) { return }
  install.installed = true;
  Vue.component('v-cloudinary-upload', component);
}

var plugin = { install: install };

var GlobalVue = null;
if (typeof window !== 'undefined') {
  GlobalVue = window.Vue;
} else if (typeof global !== 'undefined') {
  GlobalVue = global.Vue;
}
if (GlobalVue) {
  GlobalVue.use(plugin);
}

export default component;
export { install };
